/*
 Example1102A: JJ2 line following with LED blink
 H. Kawakami  November 10, 2014
*/

#include <Servo.h> 
#include <FastLED.h>

const int servoL_Pin = 9; 
const int servoR_Pin = 5; 
Servo servoL;  
Servo servoR;  
const int ledPin=4;
CRGB leds[1];

// Left: 1530-1543:1536
//Right: 1490-1503:1496
int centerR=1510, centerL=1541, pw=700;

void setup() { 
  delay(1000); 
  servoL.attach(servoL_Pin, centerL-pw, centerL+pw); 
  servoR.attach(servoR_Pin, centerR-pw, centerR+pw);
  LEDS.setBrightness(127); // 0-255
  FastLED.addLeds<WS2811, ledPin, GRB>(leds, 1);  
  Serial.begin(9600); 
}  

int spd=20;

void fwd(){
    servoL.write(90-spd);
    servoR.write(90+spd);  
}

void stp(){
    servoL.write(90);
    servoR.write(90);
}

void rot_CCW(){
    servoL.write(90);
    servoR.write(90+spd);   
}

void rot_CW(){
    servoL.write(90-spd);
    servoR.write(90); 
}

void prtData(int x, int y, int z){ 
  Serial.print("val_L:");
  Serial.print(x,DEC);
  Serial.print("   val_C:");
  Serial.print(y,DEC);
  Serial.print("   val_R:");
  Serial.println(z,DEC);
}

int th=200, val_L, val_C, val_R;
int col=127;

void loop() {
  val_L=analogRead(A0);
  val_C=analogRead(A1);
  val_R=analogRead(A2);
  prtData(val_L, val_C, val_R);
  if(val_L>th && val_C>th && val_R>th){
    stp();
    leds[0]= CRGB(0, 0, 0);
    LEDS.show();
  }else if(val_L<th && val_C>th && val_R<th){
    fwd();
    leds[0]= CRGB(0, col, 0);
    LEDS.show();
  }else if(val_L<th && val_C<th && val_R>th){
    rot_CW();
    leds[0]= CRGB(0, 0, col);
    LEDS.show();
  }else if(val_L>th && val_C<th && val_R<th){
    rot_CCW();
    leds[0]= CRGB(col, 0, 0);
    LEDS.show();
  }else{
    fwd();
    leds[0]= CRGB(0, 0, 0);
    LEDS.show();
  }
//  delay(60);
}
