/*
 Example1104A : JJ2 line following demo
 state machine model
 H. Kawakami November 10, 2014
*/

#include <Servo.h> 

const int servoL_Pin = 9; 
const int servoR_Pin = 5; 

Servo servoL;  
Servo servoR;  

// Left: 1530-1543:1536
//Right: 1490-1503:1496
int centerR=1510, centerL=1541, pw=700;

void setup() { 
  delay(1000); 
  servoL.attach(servoL_Pin, centerL-pw, centerL+pw); 
  servoR.attach(servoR_Pin, centerR-pw, centerR+pw);
  Serial.begin(9600);  
} 

int spd=30;

void fwd(){
    servoL.write(90-spd);
    servoR.write(90+spd); 
}

void stp(){
    servoL.write(90);
    servoR.write(90);
}

void rot_CCW(){
    servoL.write(90);
    servoR.write(90+spd); 
}

void rot_CW(){
    servoL.write(90-spd);
    servoR.write(90);  
}

void prtData(int x, int y, int z){ 
  Serial.print("val_L:");
  Serial.print(x,DEC);
  Serial.print("   val_C:");
  Serial.print(y,DEC);
  Serial.print("   val_R:");
  Serial.println(z,DEC);
}

int th=300, val_L, val_C, val_R;
int state=1;

void loop() {
  val_L=analogRead(A0);
  val_C=analogRead(A1);
  val_R=analogRead(A2);
  switch(state){
    case 1: //forward direction
      fwd();
      if(val_L>th && val_C>th && val_R>th){
        state=4;
      }else if(val_L<th && val_C<th && val_R>th){
        state=2;
      }else if(val_L>th && val_C<th && val_R<th){
        state=3;
      }
      break;
    case 2:  //clockwise rotation
      rot_CW();
      if(val_L>th && val_C>th && val_R>th){
        state=4;
      }else if(val_L<th && val_C>th && val_R<th){
        state=1;
      }
      break;
    case 3:  //counter clockwise rotation
      rot_CCW();
      if(val_L>th && val_C>th && val_R>th){
        state=4;
      }else if(val_L<th && val_C>th && val_R<th){
        state=1;
      }
      break;
    case 4:  // stop
      stp();
      if(!(val_L>th && val_C>th && val_R>th)){
        state=1;
      }
      break;
    default:
      break;      
  }
  delay(40);
}
